#include "starpu.h"

void mytask_cpu_func(void *buffers[], void *cl_arg);

struct starpu_codelet cl_mytask = {
  .where = STARPU_CPU,
  .cpu_funcs = {mytask_cpu_func, NULL},
  .nbuffers = 2,
  .modes = {STARPU_R, STARPU_RW},
  .name = "mytask"
};


void insert_mytask_c(starpu_data_handle_t *a_handle,
                     starpu_data_handle_t *b_handle,
                     float multiplier, int ctx) {

  int ret;

  if(ctx==-1) {
    ret = starpu_task_insert(&cl_mytask,
                             STARPU_VALUE,     &multiplier, sizeof(float),
                             STARPU_R,         *a_handle,
                             STARPU_RW,        *b_handle,
                             0);
  } else {
    ret = starpu_task_insert(&cl_mytask,
                             STARPU_VALUE,     &multiplier, sizeof(float),
                             STARPU_R,         *a_handle,
                             STARPU_RW,        *b_handle,
                             STARPU_SCHED_CTX, (unsigned)ctx,
                             0);
  }
  STARPU_CHECK_RETURN_VALUE(ret, "starpu_task_insert");
  
  return;  
}

void unpack_mytask_args(void *cl_arg,
                        float *multiplier)
{
  starpu_codelet_unpack_args(cl_arg, 
                             multiplier);
  return;
}

